#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "stdconv.h"

int val(char *sz_stringToScan, int *pint_buffer)
/* Scans a number from a string.
**
** arguments:
** sz_stringToScan --- the string to be scaned;
** pint_buffer --- the buffer that holds the result.
**
** return value:
** 1 --- String format error;
** 2 --- Number too big;
** 0 --- All right.
*/
{
	char *pchar_scanEnd;
	int ret;
	long long_scanResult;
	if(sz_stringToScan[0]){
		long_scanResult = strtol(sz_stringToScan, &pchar_scanEnd, 10);
		if(pchar_scanEnd == sz_stringToScan){
			ret = 1;
		}else{
			if(((int)long_scanResult) != long_scanResult){
				ret = 2;
			}else{
				ret = 0;
			}/* end if */
			*pint_buffer = (int)long_scanResult;
		}/* end if */
	}else{
		ret = 1;
	}/* end if */
	return ret;
}/* end function val */




int val2(char *sz_stringToScan, int *pint_buffer)
/* Scans a number from a string.
** Difference from function val: the return value.
**
** arguments:
** sz_stringToScan --- the string to be scaned;
** pint_buffer --- the buffer that holds the result.
**
** return value:
** 1 --- string format error;
** 2 --- number too big;
** 3 --- string contains not only the number;
** 0 --- all right.
*/
{
	char *pchar_scanEnd;
	int ret;
	long long_scanResult;
	if(sz_stringToScan[0]){
		long_scanResult = strtol(sz_stringToScan, &pchar_scanEnd, 10);
		if(pchar_scanEnd == sz_stringToScan){
			ret = 1;
		}else{
			if(((int)long_scanResult) != long_scanResult){
				ret = 2;
			}else if(*pchar_scanEnd){
				ret = 3;
			}else{
				ret = 0;
			}/* end if */
			*pint_buffer = (int)long_scanResult;
		}/* end if */
	}else{
		ret = 1;
	}/* end if */
	return ret;
}/* end function val */




void scanGetNum(int *num_bufp, int lbound, int rbound, char *sz_prompt, char *sz_request)
/* Scan "stdin" to get an integer.
 * parameters: num_bufp --- pointer to the target storage;
 * lbound --- smallest boundary of valid input
 * rbound --- biggest boundary of valid input
 * sz_prompt --- prompt string
 * sz_request --- show request when input is illegal
 */
{
LABEL_ScanGetNum:
	printf("%s", sz_prompt);
	if(scanGetNumSub(num_bufp)){
		puts(sz_request);
		goto LABEL_ScanGetNum;
	}else{
		if((*num_bufp) > rbound || (*num_bufp) < lbound){
			puts(sz_request);
			goto LABEL_ScanGetNum;
		}
	}
}




void scanGetDouble(double *dbl_bufp, double lbound, double rbound, char *sz_prompt, char *sz_request)
/* Scan "stdin" to get a double precision number.
 * parameters: dbl_bufp --- pointer to the target storage;
 * lbound --- smallest boundary of valid input
 * rbound --- biggest boundary of valid input
 * sz_prompt --- prompt string
 * sz_request --- show request when input is illegal
 */
{
LABEL_ScanGetDouble:
	printf("%s", sz_prompt);
	if(scanGetDoubleSub(dbl_bufp)){
		puts(sz_request);
		goto LABEL_ScanGetDouble;
	}else{
		if((*dbl_bufp) > rbound || (*dbl_bufp) < lbound){
			puts(sz_request);
			goto LABEL_ScanGetDouble;
		}
	}
}




int scanGetNumSub(int *num_bufp)
/* return code:
 * 2 --- number too large
 * 1 --- bad format
 * 0 --- all right
 */
{
	unsigned long num_buf;
	char sz_inputbuf[10], *cp_detect;
	scanf("%10s", sz_inputbuf);
	fflush(stdin);
	num_buf = strtoul(sz_inputbuf, &cp_detect, 10);
	if(!sz_inputbuf[0] || (*cp_detect)){
		return 1; /* error detected: string empty or scan not complete */
	}else{
		if(num_buf > MAXINT){
			return 2;
		}else{
			*num_bufp = (int)num_buf;
			return 0;
		}
	}
}




int scanGetDoubleSub(double *dbl_bufp)
{
	double dbl_buf;
	char sz_inputbuf[10], *cp_detect;
	scanf("%10s", sz_inputbuf);
	fflush(stdin);
	dbl_buf = strtod(sz_inputbuf, &cp_detect);
	if(!sz_inputbuf[0] || (*cp_detect)){
		return 1; /* error detected: string empty or scan not complete */
	}else{
		*dbl_bufp = dbl_buf;
		return 0;
	}
}

char *getLine(char *buffer, int size)
{
	int i;
	int ch;
	for(i = 0; i < size - 1; i++){
		ch = getc(stdin);
		if(ch == '\n' || ch == -1){
			break;
		}// end if
		buffer[i] = ch;
	}// end for
	buffer[i] = '\0';
	if(i == 0 && ch == -1){
		// already eof
		return NULL;
	}else{
		return buffer;
	}// end if
}

char *fileGetLine(char *buffer, int size, FILE *fp)
{
	int i;
	int ch;
	for(i = 0; i < size - 1; i++){
		ch = getc(fp);
		if(ch == '\n' || ch == -1){
			break;
		}// end if
		buffer[i] = ch;
	}// end for
	buffer[i] = '\0';
	if(i == 0 && ch == -1){
		// already eof
		return NULL;
	}else{
		return buffer;
	}// end if
}

BOOL waitForMore(void)
{
	char str[128];
	printf("-- MORE -- enter \'A\' to abort: ");
	getLine(str, 128);
	if(tolower(str[0]) == 'a'){ // user abort
		return FALSE;
	}else{
		return TRUE;
	}// end if
}
